/// <reference types="node" />
import * as p from "path";
import { Refined } from "ts-refined";
import { Refinement } from "ts-refined";
import { Tagged } from "ts-refined";
export declare class FPath extends Tagged<string> {
    "@nominal": "de222c7d-3565-435e-9bfc-1750a7d07838";
}
export declare class Dir extends Tagged<string> {
    "@nominal": "c9174b4e-a8c1-48b3-adfb-c84341137f1a";
}
export declare class File extends Tagged<string> {
    "@nominal": "6b7615c1-5d02-4e1a-9921-381fa3a8585e";
}
export declare class Abs implements Refinement<string> {
    "@nominal": "1a88d9e9-522c-4de1-96c0-7e5257705ca4";
    test: (s: string) => boolean;
}
export declare class Rel implements Refinement<string> {
    "@nominal": "5bed8e96-5562-444c-b42a-9bcb35a77448";
    test: (s: string) => boolean;
}
export declare type Path<A = {}> = Refined<string, FPath & A>;
export declare const basename: <A>(s: Path<A>, ext?: string) => Path<A>;
export declare const dirname: <A>(s: Path<File & A> | Path<A>) => Path<A>;
export declare const extname: (s: Path) => string;
export declare const format: (o: p.ParsedPath) => Path;
export declare const isAbsolute: <A>(s: Path<A>) => s is Path<Abs & A>;
export declare const join: <A extends Abs | Rel | {}>(s: Path<A>, ...ss: Array<Path>) => Path<A>;
export declare const normalize: <A>(s: Path<A>) => Path<A>;
export declare const parse: (s: Path) => p.ParsedPath;
export declare const relative: (from: Path, to: Path) => Path;
export declare const resolve: (...ss: Array<Path>) => Path<Abs>;
export { delimiter, posix, sep, win32 } from "path";
