"use strict";
// #+TITLE: Refinements for paths
Object.defineProperty(exports, "__esModule", { value: true });
const p = require("path");
const ts_refined_1 = require("ts-refined");
// ** Tags
class FPath extends ts_refined_1.Tagged {
}
exports.FPath = FPath;
class Dir extends ts_refined_1.Tagged {
}
exports.Dir = Dir;
class File extends ts_refined_1.Tagged {
}
exports.File = File;
// ** Refinements
class Abs {
    constructor() {
        this.test = (s) => p.isAbsolute(s);
    }
}
exports.Abs = Abs;
class Rel {
    constructor() {
        this.test = (s) => !p.isAbsolute(s);
    }
}
exports.Rel = Rel;
// ** Retyped path functions
exports.basename = p.basename;
exports.dirname = p.dirname;
exports.extname = p.extname;
exports.format = p.format;
exports.isAbsolute = p.isAbsolute;
exports.join = p.join;
exports.normalize = p.normalize;
exports.parse = p.parse;
exports.relative = p.relative;
exports.resolve = p.resolve;
var path_1 = require("path");
exports.delimiter = path_1.delimiter;
exports.posix = path_1.posix;
exports.sep = path_1.sep;
exports.win32 = path_1.win32;
